(set-option PULL_NESTED_QUANTIFIERS true)
(set-option MODEL_COMPACT true)
(set-option MBQI true)
(set-option enable-cores)

(declare-sort Statement 0)

(declare-fun Start () Statement)      
(declare-fun Infinity ()  Statement)   

(declare-sort Var 0)
(declare-fun IV (Var) Int)  
;(define-fun IV ((v Var)) Int 0)

(declare-fun E (Statement) Int)
(assert (= (E Start) 0))
(assert (< (E Start) (E Infinity)))

(declare-fun eOrd0 (Statement Statement) Bool)
(define-fun eOrd0 ((s1 Statement) (s2 Statement)) Bool (< (E s1) (E s2)))

(declare-fun inGamma0 (Var Statement) Bool)

(declare-fun isMaxBefore (Var Statement Statement) Bool)
(define-fun isMaxBefore ((v Var) (sS Statement) (sT Statement)) Bool
          (and (< (E sT) (E Infinity))
               ( or (= sT Start) (inGamma0 v sT))
               (< (E sT) (E sS))
               (forall (s Statement) (=>                                
                      (inGamma0 v s)
                      (=> (< (E s) (E sS)) (<= (E s) (E sT)) ) )
                  :pattern ((inGamma0 v s) (< (E s) (E sS)))
) ) )
;(define-fun isMaxBefore ((v Var) (sS Statement) (sT Statement)) Bool
;   ( and (inGamma0 v sT)
;         (< (E sT) (E sS))
;         (forall (s Statement) (=> (< (E s) (E sS)) 
;                                   (<= (E s) (E sT))))))

(declare-fun VAL (Var Int) Statement)                              
(assert (forall (s Statement) (v Var) 
         (=> (and (> (E s) (E Start)) (<= (E s) (E Infinity)) ) 
          (isMaxBefore v s (VAL v (E s))))))

(declare-fun s2i (Statement) Int)
; 

(declare-fun Vs2i (Var Statement) Int)
(define-fun Vs2i ((v Var) (s Statement)) Int 
  (ite (= s Start)             (IV v) (
  (ite (> (E s) (E Infinity)) 0 (
  (ite (= (VAL v (E s)) Start) (IV v) ( 
                               s2i (VAL v (E s) ) ) ) ) ) ) ) )
                              ;(s2i (VS2S v s) ) ) ) ) )

; int x;
(declare-fun x () Var)

; int y;
(declare-fun y () Var)

(assert (forall (v Var) 
         (and 
         (not (inGamma0 v Start)) (not (inGamma0 v Infinity)))))


;(assert (and (= (IV x) 0) (= (IV y) 0)))

;x=5;
(declare-fun s1 () Statement)
(assert (= (s2i s1) 5))
(assert (inGamma0 x s1))
(assert (not (inGamma0 y s1)))
(assert (eOrd0 Start s1))

;y= x + 1;
(declare-fun s2 () Statement)
(assert (= (s2i s2) (+ (Vs2i x s2) 1 )))
(assert (inGamma0 y s2))
(assert (not (inGamma0 x s2)))
(assert (eOrd0 s1 s2))

; x = y + 2
(declare-fun s3 () Statement)
(assert (= (s2i s3) (+ (Vs2i y s3) 2)))
(assert (inGamma0 x s3))
(assert (not (inGamma0 y s3)))
(assert (eOrd0 s2 s3))

(assert (eOrd0 s3 Infinity))

(assert (forall (s Statement) 
         (=> (distinct s Start s1 s2 s3 Infinity)
                       (<= (E Infinity) (E s)))))

(check-sat)
(get-unsat-core)
(model)
(echo "x(Start) x(s1) x(s2) x(s3) x(Infinity)")
(eval (Vs2i x Start) )
(eval (Vs2i x s1) )
(eval (Vs2i x s2))
(eval (Vs2i x s3))
(eval (Vs2i x Infinity))

(echo "y(Start) y(s1) y(s2) y(s3) y(Infinity)")
(eval (Vs2i y Start) )
(eval (Vs2i y s1) )
(eval (Vs2i y s2))
(eval (Vs2i y s3))
(eval (Vs2i y Infinity))
